
#include <iostream.h>
#include <math.h>

float min(float x, float y) {
  return x <= y ? x : y ;
}

class Point {
  float x ;
  float y ;
  friend float angle(Point, Point, Point) ;
public :
  Point(float X, float Y) : x(X), y(Y) {}
} ;
 
float angle(Point P, Point Q, Point R) {

  // Actually cosine of angle

  float ux, uy, vx, vy ;

  ux = P.x - Q.x ;
  uy = P.y - Q.y ;
  vx = R.x - Q.x ;
  vy = R.y - Q.y ;

  return (ux * vx + uy * vy) / sqrt((ux * ux + uy * uy) * (vx * vx + vy * vy)) ;
}

class Triangle {
  Point P ;
  Point Q ;
  Point R ;
public :
  void angles(float* RPQ, float* PQR, float* QRP) {
    *RPQ = angle(R, P, Q) ;
    *PQR = angle(P, Q, R) ;
    *QRP = angle(Q, R, P) ;
  }
  Triangle(Point& p, Point& q, Point& r) : P(p), Q(q), R(r) {}
  Triangle() : P(Point(0.0, 0.0)), Q(Point(0.0, 0.0)), R(Point(0.0, 0.0)) {}
} ;
 

float minAngle(float x, float y, float z, float t,
               float u, float v, float w) {
  Point A(0.0, 0.0) ;
  Point B(1.0, 0.0) ;
  Point C(1.0, 1.0) ;
  Point D(0.0, 1.0) ;
  Point E(x  , 0.0) ;
  Point F(0.0, y  ) ;
  Point G(z  , t  ) ;
  Point H(u  , v  ) ;
  Point I(w  , (1 - w) * t / (1 - z)) ;

  Triangle triangles [9] ;

  float result = 1.0 ;

  triangles [0] = Triangle(A, E, H) ;
  triangles [1] = Triangle(E, B, I) ;
  triangles [2] = Triangle(E, I, H) ;
  triangles [3] = Triangle(A, H, F) ;
  triangles [4] = Triangle(H, G, F) ;
  triangles [5] = Triangle(H, I, G) ;
  triangles [6] = Triangle(B, C, G) ;
  triangles [7] = Triangle(F, G, D) ;
  triangles [8] = Triangle(G, C, D) ;

  for(int i = 0 ; i < 9 ; i++) {
    float a, b, c ;

    triangles [i] . angles(&a, &b, &c) ;
    result = min(result, min(a, min(b, c))) ;
  }

  return result ;
}

main () {
  float x, y, z, t, u, v, w ;
  float maxMin = -1.0 ;

  for(int i = 0 ; i < 9 ; i++) {
    x = 0.4110 + 0.0001 * i ;
    for(int j = 0 ; j < 9 ; j++) {
      y = 0.3336 + 0.0001 * j ;
      for(int k = 0 ; k < 9 ; k++) {
	z = 0.3010 + 0.0001 * k ;
        for(int l = 0 ; l < 9 ; l++) {
	  t = 0.4057 + 0.0001 * l ;
	  for(int m = 0 ; m < 9 ; m++) {
	    u = 0.2898 + 0.0001 * m ;
	    for(int n = 0 ; n < 9 ; n++) {
	      v = 0.2427 + 0.0001 * n ;
	      for(int r = 0 ; r < 9 ; r++) {
		w = 0.4983 + 0.0001 * r ;

		float next = minAngle(x, y, z, t, u, v, w) ;

		if(next > maxMin) {
		  cout << x << " " << y << " " << z << " " << t << " "
		       << u << " " << v << " " << w << " "
		       << next << "\n" ;
		  maxMin = next ;
		}
	      }
            }
          }
        }
      }
    }
  }
}


